#############################################################
#
# iproute2
#
#############################################################
IPROUTE2_DIR=$(BUILD_DIR)/iproute2

IPROUTE2_SOURCE_URL=ftp://ftp.inr.ac.ru/ip-routing/
IPROUTE2_SOURCE=iproute2-2.4.7-now-ss020116-try.tar.gz

#Use the debian source for now, as the .ru site has availability problems
#IPROUTE2_SOURCE_URL=http://ftp.debian.org/debian/pool/main/i/iproute/
#IPROUTE2_SOURCE=iproute_20010824.orig.tar.gz
#IPROUTE2_PATCH:=iproute_20010824-8.diff.gz

HTB_PATCH=$(PATCH_DIR)/iproute2/htb3.6_tc.diff

IPROUTE2_PKG_DIR=$(PACKAGES_DIR)/iproute2

$(DL_DIR)/$(IPROUTE2_SOURCE):
	 $(WGET) -P $(DL_DIR) $(IPROUTE2_SOURCE_URL)$(IPROUTE2_SOURCE)

iproute2-source: $(DL_DIR)/$(IPROUTE2_SOURCE)

$(IPROUTE2_DIR)/.unpacked: $(DL_DIR)/$(IPROUTE2_SOURCE)
	-rm -rf $(IPROUTE2_DIR).orig $(IPROUTE2_DIR)
	zcat $(DL_DIR)/$(IPROUTE2_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	cat $(HTB_PATCH) | patch -p1 -d $(IPROUTE2_DIR)
	-[ ! -d $(IPROUTE2_PKG_DIR) ] && mkdir $(IPROUTE2_PKG_DIR)
	touch $(IPROUTE2_DIR)/.unpacked

$(IPROUTE2_DIR)/.configured: $(IPROUTE2_DIR)/.unpacked
	$(SED) "s,-I/usr/include/db3,," $(IPROUTE2_DIR)/Makefile
	$(SED) "s/rtacct arpd/rtacct/;" $(IPROUTE2_DIR)/misc/Makefile
	$(SED) "s/\$\(ARPDOBJ\)//;" $(IPROUTE2_DIR)/misc/Makefile
	touch  $(IPROUTE2_DIR)/.configured

$(IPROUTE2_DIR)/tc/tc: $(IPROUTE2_DIR)/.configured
	$(MAKE) -C $(IPROUTE2_DIR) \
		KERNEL_INCLUDE=$(LINUX_DIR)/include \
		DESTDIR=$(IPROUTE2_PKG_DIR) \
		CCOPTS="-D_GNU_SOURCE -Os -Wstrict-prototypes -Wall"

$(IPROUTE2_PKG_DIR)/sbin/ss: $(IPROUTE2_DIR)/tc/tc
	$(MAKE) -C $(IPROUTE2_DIR) \
		KERNEL_INCLUDE=$(LINUX_DIR)/include \
		DESTDIR=$(IPROUTE2_PKG_DIR) \
		CCOPTS="-D_GNU_SOURCE -Os -Wstrict-prototypes -Wall" \
		install
	-$(SSTRIP) $(IPROUTE2_PKG_DIR)/sbin/*
	rm -rf $(IPROUTE2_PKG_DIR)/usr

$(ADD_MASTER)/sbin/ip: 
	$(MAKE) -C $(IPROUTE2_DIR) \
		KERNEL_INCLUDE=$(LINUX_DIR)/include \
		DESTDIR=$(IPROUTE2_PKG_DIR) \
		CCOPTS="-D_GNU_SOURCE -Os -Wstrict-prototypes -Wall" \
		install
	-$(SSTRIP) $(IPROUTE2_PKG_DIR)/sbin/*
	rm -rf $(IPROUTE2_PKG_DIR)/usr
	mv $(IPROUTE2_PKG_DIR)/sbin/ip $(ADD_MASTER)/sbin/.
	mv $(IPROUTE2_PKG_DIR)/sbin/tc $(ADD_MASTER)/sbin/.
	-rm $(ADD_MASTER)/etc/iproute2/*
	-[ ! -d  $(ADD_MASTER)/etc/iproute2 ] \
		&& mkdir $(ADD_MASTER)/etc/iproute2
	-mv $(IPROUTE2_PKG_DIR)/etc/iproute2/* $(ADD_MASTER)/etc/iproute2/.

iproute2: $(IPROUTE2_PKG_DIR)/sbin/ss $(ADD_MASTER)/sbin/ip

iproute2-clean:
	-$(MAKE) -C $(IPROUTE2_DIR) clean
	rm -rf $(IPROUTE2_PKG_DIR)

iproute2-dirclean:
	rm -rf $(IPROUTE2_DIR)
	rm -rf $(IPROUTE2_PKG_DIR)

