#############################################################
#
# pppd
#
#############################################################

PPPD_SOURCE_URL=http://www.zelow.no/floppyfw/download/Development/src/
PPPD_SOURCE=ppp-2.4.1.pppoe4.tgz
PPPD_DIR=$(BUILD_DIR)/ppp-2.4.1.pppoe4
PPPD_PACKAGES_DIR=$(PACKAGES_DIR)/ppp

$(DL_DIR)/$(PPPD_SOURCE):
	 $(WGET) -P $(DL_DIR) $(PPPD_SOURCE_URL)$(PPPD_SOURCE)

pppd-source: $(DL_DIR)/$(PPPD_SOURCE)

$(PPPD_DIR)/.unpacked: $(DL_DIR)/$(PPPD_SOURCE)
	zcat $(DL_DIR)/$(PPPD_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	-rm $(PPPD_PACKAGES_DIR)
	cp -a $(PACKAGES_SKELETON_DIR)/ppp $(PPPD_PACKAGES_DIR)
	touch $(PPPD_DIR)/.unpacked

$(PPPD_DIR)/.configured: $(PPPD_DIR)/.unpacked
	(cd $(PPPD_DIR); \
		./configure \
	);
	touch $(PPPD_DIR)/.configured

# CFLAGS="-Os -pedantic -Wall -Wstrict-prototypes -Wmissing-prototypes" 

$(PPPD_DIR)/pppd/pppd: $(PPPD_DIR)/.configured
	(cd $(PPPD_DIR); $(MAKE) CC=/usr/bin/gcc HAS_SHADOW=n \
	);

$(PACKAGES_DIR)/ppp/sbin/pppd: $(PPPD_DIR)/pppd/pppd
	cp -a $(PPPD_DIR)/pppd/pppd $(PACKAGES_DIR)/ppp/sbin/pppd
	cp -a $(PPPD_DIR)/chat/chat $(PACKAGES_DIR)/ppp/sbin/chat
	-$(SSTRIP) $(PACKAGES_DIR)/ppp/sbin/pppd
	-$(SSTRIP) $(PACKAGES_DIR)/ppp/sbin/chat

pppd: $(PACKAGES_DIR)/ppp/sbin/pppd

pppd-clean:
	-$(MAKE) -C $(PPPD_DIR) clean
	-rm $(PPPD_PACKAGES_DIR)

pppd-dirclean:
	-rm -rf $(PPPD_DIR)
	-rm $(PPPD_PACKAGES_DIR)
